PROGRAM driver_modpk
  USE camb_interface
  USE modpkparams
  USE access_modpk, ONLY: potinit, evolve
  USE potential
  USE internals
  USE ode_path
  IMPLICIT NONE
  INTEGER*4 :: i,j,l,ii
  real*8 :: kin, pow, powt, kmin, kmax, dlnk, pmin, pmax
  real*8 :: pspivot, ptpivot
  real*8 :: ps0, ps1, ps2, pt0, pt1, pt2

  modpkoutput=.true.
  
  modpk_physical_priors=.true.
  modpk_rho_reheat = 1.d44
  modpk_w_primordial_lower=-0.333333 
  modpk_w_primordial_upper=1.0

  potential_choice = 8
  IF (potential_choice .eq. 7 .or. potential_choice .eq. 8) THEN
     flag_do_reconstruction = .true.
  ELSE
     flag_do_reconstruction = .false.
  END IF
  vparams_num = 4
  vnderivs=.false.

  slowroll_infl_end =.true.
  instreheat=.false.
  phi_infl_end=0.

  IF (flag_do_reconstruction) THEN
 
     kmin = log(1.d-5)
     kmax=log(5.)
     
     k_pivot=0.05
     reconstruction_Nefold_limit=20.5
     vparams(1) = -3
     vparams(2) = 0.1
     vparams(3) = -0.02
     vparams(4) = 3.2
     k_pivot=0.05
  ELSE
     kmin = log(5.d-4)
     kmax = log(5.d0)

     vparams(1) = -12.7
     !  vparams(2) = 0.8

     phi_init0 = 20.
     k_pivot=0.05d0
     N_pivot=56.5d0
  
  END IF

           
  ! these do not enter the SR reconstruction
  phi_init0 = 0.
  N_pivot=55.d0
  phi_init0 = 0.


  findiffdphi = epsilon(1.d0)  


  CALL potinit()


  IF(pk_bad==0) THEN    
     
     DO ii=0,500
        kin=exp(kmin+REAL(ii)*(kmax-kmin)/REAL(500))
        CALL evolve(kin,pow,powt)
        WRITE(*,*) kin,pow,powt
     END DO
  endif

!     dlnk = 2.0d0
!     call evolve(k_pivot,ps1,pt1)
!     write(*,*)
!     write(*,*) 'A_s =', ps1
!     write(*,*) 'r =', pt1/ps1
!     call evolve(k_pivot,ps0,pt0)
!     call evolve(k_pivot*exp(-dlnk),ps1,pt1)
!     call evolve(k_pivot*exp(dlnk),ps2,pt2)
!     write(*,*) 'n_s =', 1.d0+log(ps2/ps1)/dlnk/2.d0
!     write(*,*) 'n_t =', log(pt2/pt1)/dlnk/2.d0
!     write(*,*) 'dn_s/dlnk =', log(ps1*ps2/ps0**2)/dlnk**2


!!$     IF(flag_do_reconstruction) THEN
!!$
!!$        call evolve(k_pivot,ps0,pt0)
!!$        
!!$        IF (potential_choice .eq. 7) THEN   ! only options 7 and 8 for now
!!$           eps_p = vparams(1)
!!$        ELSE IF (potential_choice .eq. 8) THEN
!!$           eps_p = 10.d0**vparams(1)
!!$        END IF
!!$        eta_p = vparams(2)
!!$        xi_p = vparams(3)
!!$        H_p = getHJH(phi_ik)
!!$        WRITE(*,*) k_pivot,ps0,pt0, eps_p, eta_p, xi_p, H_p, phi_ik
!!$
!!$        gamma = 0.5772156649015d0
!!$        C =  4.*(log(2.)+gamma)-5.
!!$        cc = -2. + log(2.) + gamma
!!$        write(*,*)
!!$        write(*,*) 'Analytic predictions:'
!!$        write (*,*) 'C and cc:' , C, cc
!!$        write(*,*) 'A_s =', (1.-(2*cc+1.)*eps_p+cc*eta_p)**2*H_p**2/(8*pi**2*eps_p)
!!$        write(*,*) 'r =', 16.*eps_p*(1.+2*cc*(eps_p-eta_p))
!!$        
!!$        write(*,*) 'n_s =', 1.+2*eta_p-4.*eps_p-2.*(1.+C)*eps_p**2 &
!!$             & -0.5*(3.-5.*C)*eps_p*eta_p+0.5*(3.-C)*xi_p
!!$        write(*,*) 'n_t =', -2*eps_p-(3+C)*eps_p**2+(1+C)*eps_p*eta_p
!!$        write(*,*) 'dn_s/dlnk =', -1./(1.-eps_p)*(2.*xi_p+8.*eps_p**2-10.*eps_p*eta_p &
!!$             & + (7*C-9.)/2.*eps_p*xi_p+ (3.-C)/2.*xi_p*eta_p)
!!$     END IF

!  ELSE
!     write(*,*) 'pk_bad =', pk_bad
!  ENDIF



  STOP
END PROGRAM driver_modpk
